### Method

# FwupdPlugin Device dump_firmware

since: 1.5.0

#### Declaration [src]

    GBytes*
    fu_device_dump_firmware (
      FuDevice* self,
      FuProgress* progress,
      GError** error
    )

#### Description [src]

Reads the raw firmware image from the device by calling a plugin-specific vfunc. This raw firmware image may contain serial numbers or device-specific configuration but should be a byte-for-byte match compared to using an external SPI programmer.

Available since: 1.5.0

#### Parameters

`progress`

  Type: `FuProgress`

  A `FuProgress`.

  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GBytes`

A `GBytes`, or `NULL` for error.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.